/* (c) https://github.com/MontiCore/monticore */
/* generated by template templates.de.monticore.lang.montiarc.tagschema.ValuedTagType*/


package nfp.PowerTagSchema;

import de.monticore.lang.montiarc.tagging._symboltable.TagKind;
import de.monticore.lang.montiarc.tagging._symboltable.TagSymbol;
import org.jscience.physics.amount.Amount;

import javax.measure.quantity.Power;
import javax.measure.unit.Unit;

/**
 * Created by ValuedTagType.ftl
 */
public class PowerCmpInstSymbol extends TagSymbol {
  public static final PowerCmpInstKind KIND = PowerCmpInstKind.INSTANCE;

  public PowerCmpInstSymbol(Amount<Power> value) {
    this(KIND, value);
  }

  public PowerCmpInstSymbol(Number number, Unit<Power> unit) {
    this(KIND, number, unit);
  }

  protected PowerCmpInstSymbol(PowerCmpInstKind kind, Amount<Power> value) {
    super(kind, value);
  }

  protected PowerCmpInstSymbol(PowerCmpInstKind kind, Number number, Unit<Power> unit) {
    this(kind, number.toString().contains(".") ?
      Amount.valueOf(number.doubleValue(), unit) :
      Amount.valueOf(number.intValue(),
          unit));
  }

  public Amount<Power> getValue() {
     return getValue(0);
  }

  public Number getNumber() {
    return getValue().getExactValue();
  }

  public Unit<Power> getUnit() {
    return getValue().getUnit();
  }

  @Override
  public String toString() {
    return String.format("PowerCmpInst = %s %s",
      getNumber(), getUnit());
  }

  public static class PowerCmpInstKind extends TagKind {
    public static final PowerCmpInstKind INSTANCE = new PowerCmpInstKind();

    protected PowerCmpInstKind() {
    }
  }
}
